/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the CampaignSendout type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CampaignSendout{}

// CampaignSendout struct for CampaignSendout
type CampaignSendout struct {
	Id string `json:"id"`
	CampaignId string `json:"campaign_id"`
	SendAt time.Time `json:"send_at"`
	Status string `json:"status"`
	SentContactIds []string `json:"sent_contact_ids,omitempty"`
	Split []CampaignSendoutSplitInner `json:"split,omitempty"`
	RescheduledToId *string `json:"rescheduled_to_id,omitempty"`
	RescheduledToTime *time.Time `json:"rescheduled_to_time,omitempty"`
	RescheduledFromId *string `json:"rescheduled_from_id,omitempty"`
	RescheduledFromTime *time.Time `json:"rescheduled_from_time,omitempty"`
	Unsaved *bool `json:"unsaved,omitempty"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
}

// NewCampaignSendout instantiates a new CampaignSendout object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCampaignSendout(id string, campaignId string, sendAt time.Time, status string, createdAt time.Time, updatedAt time.Time) *CampaignSendout {
	this := CampaignSendout{}
	this.Id = id
	this.CampaignId = campaignId
	this.SendAt = sendAt
	this.Status = status
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewCampaignSendoutWithDefaults instantiates a new CampaignSendout object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCampaignSendoutWithDefaults() *CampaignSendout {
	this := CampaignSendout{}
	return &this
}

// GetId returns the Id field value
func (o *CampaignSendout) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *CampaignSendout) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *CampaignSendout) SetId(v string) {
	o.Id = v
}

// GetCampaignId returns the CampaignId field value
func (o *CampaignSendout) GetCampaignId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CampaignId
}

// GetCampaignIdOk returns a tuple with the CampaignId field value
// and a boolean to check if the value has been set.
func (o *CampaignSendout) GetCampaignIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CampaignId, true
}

// SetCampaignId sets field value
func (o *CampaignSendout) SetCampaignId(v string) {
	o.CampaignId = v
}

// GetSendAt returns the SendAt field value
func (o *CampaignSendout) GetSendAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.SendAt
}

// GetSendAtOk returns a tuple with the SendAt field value
// and a boolean to check if the value has been set.
func (o *CampaignSendout) GetSendAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SendAt, true
}

// SetSendAt sets field value
func (o *CampaignSendout) SetSendAt(v time.Time) {
	o.SendAt = v
}

// GetStatus returns the Status field value
func (o *CampaignSendout) GetStatus() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *CampaignSendout) GetStatusOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *CampaignSendout) SetStatus(v string) {
	o.Status = v
}

// GetSentContactIds returns the SentContactIds field value if set, zero value otherwise.
func (o *CampaignSendout) GetSentContactIds() []string {
	if o == nil || IsNil(o.SentContactIds) {
		var ret []string
		return ret
	}
	return o.SentContactIds
}

// GetSentContactIdsOk returns a tuple with the SentContactIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignSendout) GetSentContactIdsOk() ([]string, bool) {
	if o == nil || IsNil(o.SentContactIds) {
		return nil, false
	}
	return o.SentContactIds, true
}

// HasSentContactIds returns a boolean if a field has been set.
func (o *CampaignSendout) HasSentContactIds() bool {
	if o != nil && !IsNil(o.SentContactIds) {
		return true
	}

	return false
}

// SetSentContactIds gets a reference to the given []string and assigns it to the SentContactIds field.
func (o *CampaignSendout) SetSentContactIds(v []string) {
	o.SentContactIds = v
}

// GetSplit returns the Split field value if set, zero value otherwise.
func (o *CampaignSendout) GetSplit() []CampaignSendoutSplitInner {
	if o == nil || IsNil(o.Split) {
		var ret []CampaignSendoutSplitInner
		return ret
	}
	return o.Split
}

// GetSplitOk returns a tuple with the Split field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignSendout) GetSplitOk() ([]CampaignSendoutSplitInner, bool) {
	if o == nil || IsNil(o.Split) {
		return nil, false
	}
	return o.Split, true
}

// HasSplit returns a boolean if a field has been set.
func (o *CampaignSendout) HasSplit() bool {
	if o != nil && !IsNil(o.Split) {
		return true
	}

	return false
}

// SetSplit gets a reference to the given []CampaignSendoutSplitInner and assigns it to the Split field.
func (o *CampaignSendout) SetSplit(v []CampaignSendoutSplitInner) {
	o.Split = v
}

// GetRescheduledToId returns the RescheduledToId field value if set, zero value otherwise.
func (o *CampaignSendout) GetRescheduledToId() string {
	if o == nil || IsNil(o.RescheduledToId) {
		var ret string
		return ret
	}
	return *o.RescheduledToId
}

// GetRescheduledToIdOk returns a tuple with the RescheduledToId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignSendout) GetRescheduledToIdOk() (*string, bool) {
	if o == nil || IsNil(o.RescheduledToId) {
		return nil, false
	}
	return o.RescheduledToId, true
}

// HasRescheduledToId returns a boolean if a field has been set.
func (o *CampaignSendout) HasRescheduledToId() bool {
	if o != nil && !IsNil(o.RescheduledToId) {
		return true
	}

	return false
}

// SetRescheduledToId gets a reference to the given string and assigns it to the RescheduledToId field.
func (o *CampaignSendout) SetRescheduledToId(v string) {
	o.RescheduledToId = &v
}

// GetRescheduledToTime returns the RescheduledToTime field value if set, zero value otherwise.
func (o *CampaignSendout) GetRescheduledToTime() time.Time {
	if o == nil || IsNil(o.RescheduledToTime) {
		var ret time.Time
		return ret
	}
	return *o.RescheduledToTime
}

// GetRescheduledToTimeOk returns a tuple with the RescheduledToTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignSendout) GetRescheduledToTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.RescheduledToTime) {
		return nil, false
	}
	return o.RescheduledToTime, true
}

// HasRescheduledToTime returns a boolean if a field has been set.
func (o *CampaignSendout) HasRescheduledToTime() bool {
	if o != nil && !IsNil(o.RescheduledToTime) {
		return true
	}

	return false
}

// SetRescheduledToTime gets a reference to the given time.Time and assigns it to the RescheduledToTime field.
func (o *CampaignSendout) SetRescheduledToTime(v time.Time) {
	o.RescheduledToTime = &v
}

// GetRescheduledFromId returns the RescheduledFromId field value if set, zero value otherwise.
func (o *CampaignSendout) GetRescheduledFromId() string {
	if o == nil || IsNil(o.RescheduledFromId) {
		var ret string
		return ret
	}
	return *o.RescheduledFromId
}

// GetRescheduledFromIdOk returns a tuple with the RescheduledFromId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignSendout) GetRescheduledFromIdOk() (*string, bool) {
	if o == nil || IsNil(o.RescheduledFromId) {
		return nil, false
	}
	return o.RescheduledFromId, true
}

// HasRescheduledFromId returns a boolean if a field has been set.
func (o *CampaignSendout) HasRescheduledFromId() bool {
	if o != nil && !IsNil(o.RescheduledFromId) {
		return true
	}

	return false
}

// SetRescheduledFromId gets a reference to the given string and assigns it to the RescheduledFromId field.
func (o *CampaignSendout) SetRescheduledFromId(v string) {
	o.RescheduledFromId = &v
}

// GetRescheduledFromTime returns the RescheduledFromTime field value if set, zero value otherwise.
func (o *CampaignSendout) GetRescheduledFromTime() time.Time {
	if o == nil || IsNil(o.RescheduledFromTime) {
		var ret time.Time
		return ret
	}
	return *o.RescheduledFromTime
}

// GetRescheduledFromTimeOk returns a tuple with the RescheduledFromTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignSendout) GetRescheduledFromTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.RescheduledFromTime) {
		return nil, false
	}
	return o.RescheduledFromTime, true
}

// HasRescheduledFromTime returns a boolean if a field has been set.
func (o *CampaignSendout) HasRescheduledFromTime() bool {
	if o != nil && !IsNil(o.RescheduledFromTime) {
		return true
	}

	return false
}

// SetRescheduledFromTime gets a reference to the given time.Time and assigns it to the RescheduledFromTime field.
func (o *CampaignSendout) SetRescheduledFromTime(v time.Time) {
	o.RescheduledFromTime = &v
}

// GetUnsaved returns the Unsaved field value if set, zero value otherwise.
func (o *CampaignSendout) GetUnsaved() bool {
	if o == nil || IsNil(o.Unsaved) {
		var ret bool
		return ret
	}
	return *o.Unsaved
}

// GetUnsavedOk returns a tuple with the Unsaved field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignSendout) GetUnsavedOk() (*bool, bool) {
	if o == nil || IsNil(o.Unsaved) {
		return nil, false
	}
	return o.Unsaved, true
}

// HasUnsaved returns a boolean if a field has been set.
func (o *CampaignSendout) HasUnsaved() bool {
	if o != nil && !IsNil(o.Unsaved) {
		return true
	}

	return false
}

// SetUnsaved gets a reference to the given bool and assigns it to the Unsaved field.
func (o *CampaignSendout) SetUnsaved(v bool) {
	o.Unsaved = &v
}

// GetCreatedAt returns the CreatedAt field value
func (o *CampaignSendout) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *CampaignSendout) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *CampaignSendout) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *CampaignSendout) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *CampaignSendout) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *CampaignSendout) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

func (o CampaignSendout) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CampaignSendout) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["campaign_id"] = o.CampaignId
	toSerialize["send_at"] = o.SendAt
	toSerialize["status"] = o.Status
	if !IsNil(o.SentContactIds) {
		toSerialize["sent_contact_ids"] = o.SentContactIds
	}
	if !IsNil(o.Split) {
		toSerialize["split"] = o.Split
	}
	if !IsNil(o.RescheduledToId) {
		toSerialize["rescheduled_to_id"] = o.RescheduledToId
	}
	if !IsNil(o.RescheduledToTime) {
		toSerialize["rescheduled_to_time"] = o.RescheduledToTime
	}
	if !IsNil(o.RescheduledFromId) {
		toSerialize["rescheduled_from_id"] = o.RescheduledFromId
	}
	if !IsNil(o.RescheduledFromTime) {
		toSerialize["rescheduled_from_time"] = o.RescheduledFromTime
	}
	if !IsNil(o.Unsaved) {
		toSerialize["unsaved"] = o.Unsaved
	}
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	return toSerialize, nil
}

type NullableCampaignSendout struct {
	value *CampaignSendout
	isSet bool
}

func (v NullableCampaignSendout) Get() *CampaignSendout {
	return v.value
}

func (v *NullableCampaignSendout) Set(val *CampaignSendout) {
	v.value = val
	v.isSet = true
}

func (v NullableCampaignSendout) IsSet() bool {
	return v.isSet
}

func (v *NullableCampaignSendout) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCampaignSendout(val *CampaignSendout) *NullableCampaignSendout {
	return &NullableCampaignSendout{value: val, isSet: true}
}

func (v NullableCampaignSendout) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCampaignSendout) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


